(function() {
  var Helpers;

  Helpers = (function() {
    function Helpers() {}

    Helpers.urlencode = function(param) {
      param = (param + '').toString();
      return encodeURIComponent(param).replace(/!/g, '%21').replace(/'/g, '%27').replace(/\(/g, '%28').replace(/\)/g, '%29').replace(/\*/g, '%2A').replace(/\~/g, '%7E').replace(/%20/g, '+');
    };

    Helpers.buildQuery = function(params) {
      var add, buildParams, j, key, len, result, value;
      result = [];
      add = function(key, value) {
        value = typeof value === 'function' ? value() : (value === null ? '' : value);
        return result.push(encodeURIComponent(key) + '=' + encodeURIComponent(value));
      };
      buildParams = function(key, value) {
        var i, j, k, len, results, results1, v;
        if (Object.prototype.toString.call(value) === '[object Array]') {
          results = [];
          for (i = j = 0, len = value.length; j < len; i = ++j) {
            v = value[i];
            if (/\[\]$/.test(key) === true) {
              results.push(add(key, v));
            } else {
              results.push(buildParams(key + '[' + (typeof v === 'object' ? i : '') + ']', v));
            }
          }
          return results;
        } else if (Object.prototype.toString.call(value) === '[object Object]') {
          results1 = [];
          for (k in value) {
            v = value[k];
            results1.push(buildParams(key + '[' + k + ']', v));
          }
          return results1;
        } else {
          return add(key, value);
        }
      };
      if (Object.prototype.toString.call(params) === '[object Array]') {
        for (key = j = 0, len = params.length; j < len; key = ++j) {
          value = params[key];
          add(key, value);
        }
      } else {
        for (key in params) {
          value = params[key];
          buildParams(key, value);
        }
      }
      return result.join('&').replace(/%20/g, '+');
    };

    return Helpers;

  })();

  module.exports = Helpers;

}).call(this);
